window.info_magnolia_periscope_ai_speech_BrowserSpeechRecognizer = function () {
  var SpeechRecognition = SpeechRecognition || webkitSpeechRecognition;
  // var SpeechGrammarList = SpeechGrammarList || webkitSpeechGrammarList;
  // var SpeechRecognitionEvent = SpeechRecognitionEvent || webkitSpeechRecognitionEvent;

  var self = this;
  var isSpeaking = false;

  if (SpeechRecognition) {
    self.initialize();

    var recognition = new SpeechRecognition();
    recognition.lang = 'en-US';
    recognition.interimResults = false;
    recognition.maxAlternatives = 1;
    recognition.continuous = false;

    recognition.onresult = function (event) {
      var transcript = event.results[0][0].transcript;
      self.speechRecorded(transcript);
      document.getElementsByClassName("v-button-voice")[0].classList.remove("recording");
    };
    recognition.onspeechend = function () {
      self.speechRecorded("");
      isSpeaking = false;
    };

    this.record = function () {
      recognition.start();
      document.getElementsByClassName("v-button-voice")[0].classList.add("recording");
      recognition.onspeechstart = function () {
        isSpeaking = true;
      };
      setTimeout(function () {
        if (!isSpeaking) {
          recognition.stop();
          self.speechRecorded("");
          document.getElementsByClassName("v-button-voice")[0].classList.remove("recording");
        }
      }, 2000);
    };

    this.abort = function () {
      recognition.abort();
      document.getElementsByClassName("v-button-voice")[0].classList.remove("recording");
    };
  }
};
